package dev.pfaff.altargui.util.listenable;

import java.util.function.Consumer;
import java.util.function.Function;

public interface ValueListenable<T> extends Listenable {
	/**
	 * Adds a listener. The listener <em>may</em> not be added again if already added. When added, it is guaranteed to
	 * be invoked immediately with the current value.
	 */
	ListenerDisposer addListener(Consumer<T> listener);

	@Override
	default ListenerDisposer addListener(Runnable listener) {
		return addListener(_ -> listener.run());
	}

	default <R> ValueListenable<R> map(Function<T, R> mapper) {
		return new MappingListenableValue<>(this, mapper);
	}
}
